#!/bin/bash
#
# Install script for Delebgate of WebPerMoS
# 
# (C) 2003 Dr. Pankaj Jalote, Shashikant Kore 
#  Department of CSE, IIT Kanpur
#

INSTALL_PATH=/usr/local/webtest

# Stop the daemon
/etc/init.d/permosd stop

# Remove the daemon service 
/sbin/chkconfig --del permosd

# Remove the daemon script
rm -f /etc/init.d/permosd

# Remove the Delegate installation jar file and configuration files
rm -f ${INSTALL_PATH}/*

# Remove the installation directory 
rmdir $INSTALL_PATH

echo "====================================="
echo "* Un-Installation Successful!"
echo "*	Thank You for using Delegate"
echo "* In case of any queries contact us"
echo "* smkore@cse.iitk.ac.in"
echo "====================================="
