#!/bin/bash
#JARFILE="$(ls PerMoS/*.jar)"

echo $1

JARFILE=$1

cat PerMoS/permosd.in.tmp | sed -e "s#permos=#permos=/usr/local/webtest/$JARFILE#" > PerMoS/permosd.in

rm -f PerMoS/permosd.in.tmp

# change the file permission as executable becasue ant has removed those permossions
chmod +x PerMoS/install.sh
chmod +x PerMoS/uninstall.sh

if [ -f PerMoS.tar.gz ]; then
	rm -f PerMoS.tar.gz
fi

tar zcv PerMoS --preserve-permissions -f PerMoS.tar.gz 

