/**********************************************************.
 * This program is to display the form.
 * The use will enter various parameters. 
 * The info is written to "userinfo.conf" and "proxy.conf" files.
 * Once those files are created, the program exits.
 *
 */

import java.io.*;

public class ShowForm
{

	public static void main(String args[])
	{
		
		final   String BASE_DIR_CONF = new String("C:/PerMos/conf/");
		final String  userInfoFile = new String(BASE_DIR_CONF + "userinfo.conf");

		// configure various parameters for Delegate
		ConfigDelegateUser c = new ConfigDelegateUser();
		
		File usrfl = new File(userInfoFile);
		if (!usrfl.exists()) 
		{
			// if userinfo file does not exist, create a form and get info
			Form	f = new	Form();
			f.waitForInfo();

			c.userInfo(f.name,f.email,f.region,f.city,f.link,f.os, f.priv);
			if (f.usePr)
			{
				// proxy is being used
				// call appropriate constructor with parameters
				ConfigProxy cpr	= new ConfigProxy("YES", f.proxyURL, f.proxyPort, f.proxyUsr, f.proxyPass, f.noProxy);
				cpr = null;
			}
			else // proxy is not used
			{
				ConfigProxy cpr = new ConfigProxy("NO");
				cpr = null;
			}
			f.dispose();
			f	= null;
			
		} // end if user info file exists
		System.exit(0);
	}
}
