
/**.
 *      Job Details associated with a Job
 *      Includes JobID and the list of parameters for each page.
 *
 */

import java.lang.*;
import java.util.*;

class JobDetails
{
	String JobID;
	
	// List of all the steps in the transaction. Each element of the ArrayList is object PageDetails
	ArrayList ListPageDetails; 

	JobDetails()
	{
		JobID = new String();
		ListPageDetails = new ArrayList();
	}

	public String getJID()
	{
		return JobID;
	}

	public String toString()
	{
		
		String	tmpStr = new String("");
		String	nl = new String("\n");	// new line

		tmpStr += "*** JobDetails *** " + nl;
		tmpStr += "JobID           " + JobID + nl;

		int i=0;
		PageDetails p = new PageDetails();
		
		while (i < ListPageDetails.size())
		{
			p = (PageDetails) ListPageDetails.get(i);
			tmpStr += p.toString();
			i++;
		}
		tmpStr += "*** JobDetails *** " + nl;
		
		return tmpStr;	
	}
}
 
