<?php
session_start();
if ($_SESSION['login'] =="")
{
	$error = "Not Logged In";
	header("Location: login.php");
} 
if (!session_is_registered('numsteps')) // number of steps in transaction
	session_register('numsteps');

if (!session_is_registered('pnum1')) // number of parameters in step 1 of transaction
	session_register('pnum1');
if (!session_is_registered('pnum2')) // number of parameters in step 2 of transaction
	session_register('pnum2');
if (!session_is_registered('pnum3')) // number of parameters in step 3 of transaction
	session_register('pnum3');


if($HTTP_POST_VARS['id'] == "tra") /* transaction information to be added */
{
	$_SESSION['numsteps']	= $_POST['Tstep'];	// get number of steps
	$_SESSION['pnum1']	= $_POST['Parnum1'];	// get number of parameters for step 1
	$_SESSION['pnum2']	= $_POST['Parnum2'];	// get number of parameters for step 2
	$_SESSION['pnum3']	= $_POST['Parnum3'];	// get number of parameters for step 3

	$jobtype = "TRA"; // Currently on job type of transaction is supported. In future it might include MAIL/TRACEROUTE..
	$fromd   = $_POST['FYear']."-".$_POST['FMonth']."-".$_POST['FDate'];
	$tod   = $_POST['TYear']."-".$_POST['TMonth']."-".$_POST['TDate'];
	
	/*	While calculating pph, earlier ceil function was used, which was overly pessimistic approach.
	 * 	Whereas using floor errs on optmistic side. 
	 *	"round" seems to be a much better choice than earlier two.
	 */
	$pph = round(($_POST['Tstep'])*($_POST['Nsamp'])/($_POST['EHour'] - $_POST['SHour'])); 
	
	/* code for adding this info in table */
	
	// create the query string
	$ins_traq = "INSERT INTO TmpJobInfo (JobID,CLogin,JName,JType,FrmDt,ToDt,StTime,EndTime,NumSamp,NumStep,NumDel,PPHLoad) VALUES ( '{$_POST['Jid']}','{$_SESSION['login']}','{$_POST['Tname']}', '$jobtype','$fromd','$tod','{$_POST['SHour']}', '{$_POST['EHour']}', '{$_POST['Nsamp']}','{$_POST['Tstep']}',  '{$_POST['Ndel']}', '$pph');";


	// store the transaction info in temporary table
	$dbconn = mysql_connect("server_name", "user_name", "password" ) or die("Unable to connect to server."); 
	$result = mysql_select_db("databse_name", $dbconn)  or die ("Unable to select database.");
	mysql_query($ins_traq) or die ("Unable to get results.");;	// values inserted in database; 
	mysql_close($dbconn);	/* Closing connection */

}  /* end id == "tra" */

if($HTTP_POST_VARS['id'] == "pg") /*  add page info */
{

	$paramstr ="";	// the parameters for the page
	$valstr = "";	// the values for respective parameters

	$npar	= 0;	// number of parameters for this page - initialize to 0
	switch ($_POST['Stepnum'])
	{
		case 1 : $npar = $_SESSION['pnum1']; break;
		case 2 : $npar = $_SESSION['pnum2']; break;
		case 3 : $npar = $_SESSION['pnum3']; break;
	}

	if ($npar > 0 )
	{
		// process the parameters and their values
		$par = array("{$_POST['param1']}", "{$_POST['param2']}", "{$_POST['param3']}", "{$_POST['param4']}", "{$_POST['param5']}", "{$_POST['param6']}", "{$_POST['param7']}", "{$_POST['param8']}", "{$_POST['param9']}", "{$_POST['param10']}" );
		$val = array( "{$_POST['val1']}", "{$_POST['val2']}", "{$_POST['val3']}", "{$_POST['val4']}", "{$_POST['val5']}", "{$_POST['val6']}", "{$_POST['val7']}", "{$_POST['val8']}", "{$_POST['val9']}", "{$_POST['val10']}" );
		
		for($i=0; $i<$npar;$i++)
		{
			if ($par[$i] == "")
				break;
			$paramstr = $paramstr.$par[$i]."|";
			$valstr = $valstr.$val[$i]."|";
		}
	} // end if npar>0

	// process keywords
	$keystr ="";

	if ($_POST['Keyword'] != "") // if keyword field not empty, generate the key string
	{
		/* Use space as tokenizing characters as well  */
		$tok = strtok($_POST['Keyword']," ");
		if (($tok != " ") && ($tok !="")) 
			$keystr = $keystr.$tok."|";
		while ($tok) 
		{
			$tok = strtok(" \n\t");
			if (($tok != " ") && ($tok !="")) 
				$keystr = $keystr.$tok."|";
		}
	}

	$ins_pgq = ""; // query string for inserting info of a transaction step
	$ins_dq  = ""; // query string for inserting data sets for particular page

	if ($npar > 0 )
	{
		//query to insert transaction details of each page
		$ins_pgq = "INSERT INTO TmpTrDetail(JobID, StepNum, HMethod, HVersion, PgURL, Port, ParamStr) VALUES ( '{$_POST['Jid']}', '{$_POST['Stepnum']}', '{$_POST['Hmethod']}', '{$_POST['Hvers']}', '{$_POST['Purl']}', '{$_POST['Pport']}', '$paramstr' );" ;

		// query to insert data set
		$ins_dq = "INSERT INTO TmpTrDataSet(JobID, StepNum,DSet,KeyWord) VALUES ('{$_POST['Jid']}', '{$_POST['Stepnum']}','$valstr','$keystr');";

	} // end if npar>0

	else	// no parameter for the page
	{
		//query to insert transaction details of each page
		$ins_pgq = "INSERT INTO TmpTrDetail(JobID, StepNum, HMethod, HVersion, PgURL, Port) VALUES ( '{$_POST['Jid']}', '{$_POST['Stepnum']}', '{$_POST['Hmethod']}', '{$_POST['Hvers']}', '{$_POST['Purl']}', '{$_POST['Pport']}');" ;

		if ($keystr != "")	// keyword string is not null - it needs to be inserted
		 // query to insert keywords
		$ins_dq = "INSERT INTO TmpTrDataSet(JobID, StepNum,KeyWord) VALUES ('{$_POST['Jid']}', '{$_POST['Stepnum']}','$keystr');";

	}

	// store the transaction info in temporary table
	$dbconn = mysql_connect("server_name", "user_name", "password" ) or die("Unable to connect to server."); 
	$result = mysql_select_db("databse_name", $dbconn)  or die ("Unable to select database.");
	mysql_query($ins_pgq) or die ("Unable to get results for ins_pgq");;	// values inserted in database; 

	if ($npar > 0 )
	{
		mysql_query($ins_dq) or die ("Unable to get results for ins_dq");;	// values inserted in database; 
	}
	else	// no parameters for the page
	{	
		if ($keystr != "")	// if keystring not empty, insert keywords 
			mysql_query($ins_dq) or die ("Unable to get results for ins_dq");;	// values inserted in database; 
	} // end if npar > 0
	mysql_close($dbconn);	/* Closing connection */

} /* end id == "pg" */

if($HTTP_POST_VARS['id'] == "del") /*  add delegate info */
{
	$ins_prefq = "";

	$dbconn = mysql_connect("server_name", "user_name", "password" ) or die("Unable to connect to server."); 
	$result = mysql_select_db("databse_name", $dbconn)  or die ("Unable to select database.");

	if (($_POST['Dloc'] != "Any") || ($_POST['Dlink'] != "Any"))
	{
		$ins_prefq = "INSERT INTO DelegatePref(JobID,DReg,PrefLink,NumDel) VALUES('{$_POST['Jid']}', '{$_POST['Dloc']}','{$_POST['Dlink']}','{$_POST['Numdel']}')";

		mysql_query($ins_prefq) or die ("Unable to get results.");;	// values inserted in database; 		
	}

	/* transfer all the data from temporary tables to final tables */

	// transfer job details
	$ret_detq = "SELECT * FROM TmpTrDetail WHERE JobID='{$_POST['Jid']}';" ;	// retrieve details
	$res = mysql_query($ret_detq) or die("Unable to retrieve from database: ret_detq");	
	while ($row = mysql_fetch_assoc($res))
	{
		$ins_pgq = "INSERT INTO TrDetail(JobID, StepNum, HMethod, HVersion, PgURL, Port, ParamStr) VALUES ( '{$row['JobID']}', '{$row['StepNum']}', '{$row['HMethod']}', '{$row['HVersion']}', '{$row['PgURL']}', '{$row['Port']}', '{$row['ParamStr']}' );" ;

		mysql_query($ins_pgq) or die("unable to insert into final table trdetail: ins_pgq");
	}
	mysql_free_result($res);

	// transer datasets and keywords 
	$ret_keyq = "SELECT * FROM TmpTrDataSet WHERE JobID='{$_POST['Jid']}';" ;	// retrieve datasets 
	$res = mysql_query($ret_keyq) or die("Unable to retrieve from database: ret_detq");	
	while ($row = mysql_fetch_assoc($res))
	{
		$ins_keyq = "INSERT INTO TrDataSet(JobID,StepNum,DSet,KeyWord) VALUES ('{$row['JobID']}', '{$row['StepNum']}', '{$row['DSet']}', '{$row['KeyWord']}' );";

		mysql_query($ins_keyq) or die("unable to insert into final table trdataset: ins_keyq");
	}
	mysql_free_result($res);


	// transfer job info
	$ret_jobq = "SELECT * FROM TmpJobInfo WHERE JobID='{$_POST['Jid']}';" ;	// retrieve job info 
	$res = mysql_query($ret_jobq) or die("Unable to retrieve from database: ret_detq");	
	$row = mysql_fetch_assoc($res);

	$ins_traq = "INSERT INTO JobInfo (JobID,CLogin,JName,JType,FrmDt,ToDt,StTime,EndTime,NumSamp,NumStep,NumDel,PPHLoad) VALUES ('{$row['JobID']}','{$row['CLogin']}', '{$row['JName']}','{$row['JType']}','{$row['FrmDt']}','{$row['ToDt']}','{$row['StTime']}','{$row['EndTime']}','{$row['NumSamp']}','{$row['NumStep']}','{$row['NumDel']}','{$row['PPHLoad']}');";

	mysql_free_result($res);
	mysql_query($ins_traq) or die("unable to insert into final table jobinfo: ins_traq");


	// write code to send email giving job details

	mysql_close($dbconn);	/* Closing connection */

} /* end id == "del" */

if ($_SESSION['curstep'] == $_SESSION['numsteps']) /* page info done. get delegate pref */
{
	$_SESSION['curstep'] += 1;
?>


<html>
<head> <title> Give Delegate Preferences </title> </head>
<body>

<form method="post" action="addstep.php">
<input type="hidden" name="id" value="del">
<input type="hidden" name="Jid" value=
<?php

echo "\"".$_SESSION['jobid']."\">";

?>
<table>
<tr> 
	<td> Delegate Location</td> 
	<td> Link to internet </td> 
	<td> Number of Delegates </td> 
</tr> 
<tr>
	<td> 
	<select name="Dloc" > 

	<option value="Any" >Any
	<option value="Africa" >Africa 
	<option value="Asia" >Asia 
	<option value="AsiaPac" >Asia Pacific 
	<option value="Europe" >Europe
	<option value="India" >India 
	<option value="LatinAm" >Latin America
	<option value="MiddleE" >Middle East
	<option value="NAmerica" >North America
	</select>
	</td>
	<td> 
	<select name="Dlink" >  
	<option value="Any">Any
	<option value="Cable">Cable Modem   
	<option value="D33">Dial Up 33kbps
	<option value="D56">Dial Up 56kbps
	<option value="DSL">DSL
	<option value="ISDN">ISDN
	<option value="T1">T1
	<option value="T2">T2
	<option value="WL">Wireless
	</select>
	</td>
	<td> 
	<input type="text" name="Numdel" maxlength="3">  
	</td>
</tr>
<tr>
	<td> </td>
	<td> <input type="submit" name="submit"> </td>
	<td> </td>
</tr>
</table>
</form>

</html>

<?php
exit();

} // end of curstep==numsteps


if ($_SESSION['curstep'] < $_SESSION['numsteps']) 
{
$_SESSION['curstep'] += 1;
$numpar	  = 0;

switch ($_SESSION['curstep'])
{
	case 1 : $numpar = $_SESSION['pnum1']; break;
	case 2 : $numpar = $_SESSION['pnum2']; break;
	case 3 : $numpar = $_SESSION['pnum3']; break;
}

?>

<html>
<head> <title> Add Step info of transaction </title> </head>
<body>

<form method="post" action="addstep.php">
<input type="hidden" name="id" value="pg">
<input type="hidden" name="Jid" value=
<?
echo "\"".$_SESSION['jobid']."\">";
?>
<input type="hidden" name="Stepnum" value=
<?
echo "\"".$_SESSION['curstep']."\">";
?>
<table >
<tr> 
	<td> Job ID </td> 
	<td> <? echo $_SESSION['jobid']; ?> </td>
</tr>
<tr> 
	<td> Transaction Step Number </td> 
	<td>
		<? echo $_SESSION['curstep'];	?>
	</td>
</tr>
<tr> 
	<td> HTTP Method </td> 
	<td> 
	<select name="Hmethod" >  
	<option>GET
	<option>POST
	</select>
	</td>
</tr>
<tr> 
	<td> HTTP Version </td> 
	<td> 
	<select name="Hvers" >  
	<option>1.0
	<option>1.1
	</select>
	</td>
</tr>
<tr>
	<td> URL of Page</td>
	<td> <input type="text" name="Purl" maxlength="100"> <br>
</tr> 
<tr>
	<td> Port Number </td>
	<td> <input type="text" name="Pport" maxlength="5"> <br>
</tr> 
 
<?

if ($numpar > 0)
{

	$indp = 1; // index variable 
		
	for (;$indp <= $numpar; $indp +=1)
	{
	echo "<tr> ";
	echo "<td> Parameter  ".$indp." <input type=\"text\" name=\"param".$indp."\" maxlength=\"20\"> </td>";
	echo "<td> Value ".$indp."  <input type=\"text\" name=\"val".$indp."\" maxlength=\"50\"> </td>";
	echo "</tr>";
	}// end for loop
} //end if 
	
?>


<tr>
	<td> Keywords </td> 
	<td> <input type="text" name="Keyword" maxlength="25">  </td> 
</tr>
<tr>
	<td> </td>
	<td> <input type="submit" name="submit"> </td>
</tr>
</table>
</form>

</body>
</html>

<?

exit();
} // end $curstep < $numstep 

 
if ($_SESSION['curstep'] > $_SESSION['numsteps']) // work done 
{
session_unregister('jobid');
session_unregister('curstep');

?>

<html><head>
<meta http-equiv="Refresh" content="0; URL=welcome.php">
<title>Redirecting</title>
</head>
Please wait. If you are not taken to welcome page, click <a href="welcome.php"> Here </a>
</html>

<?
} // end else

?>
