<?

/*	
 *	CURRENTLY NOT USED..... NEEDS LOT OF IMPROVEMENTS. 
 *
 *
 *	Detail page results. 
 * 	Generating bar graph giving details of a page.
 *	Minimum/Average/Maximum response time for each of the component is shown on the graph
 *	The interval for the results can also be specified. 
 *	The results will either be for a single day for a specified date or for a speficied period.
 *	
 *
 */

/*	if (!session_is_registered('login') || ($login==""))
	{
		$error = "error";
		header("Location: login.php");
	} 
*/

	// add http header to make sure that the response is not cached
	header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); 

	// Read the parameters from request

	$jobid	= $_GET['jid']; 	// Job ID
	$stnum	= $_GET['stnum'];	// Step number for which results are to be shown
	$location = $_GET['loc'];	// Location of Delegate

	// start day of result
	$stday	= $_GET['std']; // day
	$stmon	= $_GET['stm']; // month
	$styr	= $_GET['sty']; // year
	$day1 = strtotime($styr."-".$stmon."-".$stday."-");	// timestamp for starting day

	// duration for which result is to be shown
	// 1 : show result only for one day
	// 2 : show result for specified interval 
	$dur 	= $_GET['dur'];	

	if ($dur == 2) 
	{
		// end day of result
		$enday	= $_GET['end'];	// day
		$enmon	= $_GET['enm'];	// month
		$enyr	= $_GET['eny'];	// year
		$day2 = strtotime($enyr."-".$enmon."-".$enday."-");	// timestamp for ending day
	}
	else	// show result for a single day 
	{
		// create timestamp for next day
		$day2 = $day1 + 24*60*60; 
	}

	$diff = ($day2-$day1)/(24*60*60); // difference in number of days

	if ($diff > 7) // if the difference between days is greater than 7 days, give error message
	{
		exit();	
	}

	// select results for given interval
	$str1	= "SELECT UNIX_TIMESTAMP(TrStart) as ts, AVG(CmpDL) as avgDL, MIN(CmpDL) as minDL, MAX(CmpDL) as maxDL, CmpURL " ;
	$str2	= "FROM PgResDetail, DelegateInfo ";
	$str3	= "WHERE JobID='".$jobid."' AND  PgResDetail.DelID = DelegateInfo.DelID AND DelegateInfo.DReg='".$location."' AND  StepNum='".$stnum."' AND CmpErr < 1 AND UNIX_TIMESTAMP(TrStart) BETWEEN ".$day1." AND ".$day2."  ";
	$str4	= "GROUP BY CmpURL ;";

	$resdet_q = $str1." ".$str2." ".$str3." ".$str4;

//	echo $resdet_q."\n";
//	exit();

	$dbconn = mysql_connect("server_name", "user_name", "password" ) or die("FAIL"); 
	$result = mysql_select_db("databse_name", $dbconn)  or die ("FAIL");

	$res	= mysql_query($resdet_q) or die("Unable to execute query");

	$numrows = mysql_num_rows($res);

	while ($row = mysql_fetch_assoc($res))
	{
		$url 	= $row['CmpURL'];		// Get the URL of the component
		$fname 	= substr(strrchr($url, "/"),1);	// Get the file name from the given URL

		// The HTML code of the page is also considered a component. 
		// It has to be removed from this result. 
		// For the time being, it has been removed with an inelegant method 
		// Filter out the component using threshold of response time 
		if ($row['avgDL'] > 5000)	
			continue;
		$datax[]= $fname;
		$avg[]	= ceil($row['avgDL']);	// average download time
		$min[]	= ceil($row['minDL']);	// minimum download time
		$max[]	= ceil($row['maxDL']);	// maximum download time

	}// end while
	
	include ("jpgraph/jpgraph.php");
	include ("jpgraph/jpgraph_bar.php");

	// Size of graph
	$width=500; 

	// height of graph is decided depending on number of components
	$height=1000;

	// Set the basic parameters of the graph 
	$graph = new Graph($width,$height,'auto');
	$graph->SetScale("textlin");

	// margins 
	$top = 40;
	$bottom = 70;
	$left = 110;
	$right = 40;
	$graph->Set90AndMargin($left,$right,$top,$bottom);

	// Nice shadow
	$graph->SetShadow();
	$graph->SetColor('ivory');

	// Show  grid in background
	$graph->xgrid->Show();

	// Setup margin and titles 
	$graph->SetMarginColor("antiquewhite");

	if ($dur == 1 ) // result for a single day
	{
		$titlestr = date("M d, Y", $day1);
		$graph->title->Set($titlestr); // date is the title 
	}
	else	// result for a specified period
	{
		$st1 		=  date("M d, Y", $day1);
		$st2 		=  date("M d, Y", $day2);
		$titlestr 	= $st1." -TO- ".$st2;
		$graph->title->Set($titlestr); // date is the title 
	}

	// Setup X-axis
	$graph->xaxis->SetTickLabels($datax);

	// Some extra margin looks nicer
	$graph->xaxis->SetLabelMargin(5);

	// Label align for X-axis
	$graph->xaxis->SetLabelAlign('right','center');


	// Add some grace to y-axis so the bars doesn't go
	// all the way to the end of the plot area
	$graph->yaxis->scale->SetGrace(15);

	// Setup the Y-axis to be displayed in the bottom of the 
	// graph. We also finetune the exact layout of the title,
	// ticks and labels to make them look nice.
	$graph->yaxis->SetPos('max');

	// First make the labels look right
	$graph->yaxis->SetLabelAlign('center','top');
	$graph->yaxis->SetLabelFormat('%d');
	$graph->yaxis->SetLabelSide(SIDE_RIGHT);

	// The fix the tick marks
	$graph->yaxis->SetTickSide(SIDE_LEFT);

	// Only draw labels on every 3rd tick mark 
	$graph->yaxis->SetTextLabelInterval(3); 

	// Finally setup the title
	$graph->yaxis->SetTitleSide(SIDE_RIGHT);
	$graph->yaxis->SetTitleMargin(20);

	// To align the title to the right use :
	$graph->yaxis->SetTitle('Response Time in millisecond','high');
	$graph->yaxis->title->Align('right');


	// To center the title use :
	//$graph->yaxis->SetTitle('Turnaround 2002','center');
	//$graph->yaxis->title->Align('center');

	// $graph->yaxis->title->SetFont(FF_ARIAL,FS_BOLD,12);
	$graph->yaxis->title->SetAngle(0);

	// Set footer 
	// In horizontal bar graph the footer is added as text 
	$str = new Text("Generated at  ".gmdate("H:i:s M d Y", time())." GMT",$width-235,$height-25);
	$graph->AddText($str);
	$str1 = new Text("(C) CSE, IIT Kanpur",10,$height-25);
	$graph->AddText($str1);

	// set legend position and direction
	$graph->legend->Pos(0.01,0.01,"right","top");
	$graph->legend->SetLayout(LEGEND_VER);
	$graph->legend->SetLineWeight(2);

	// Now create a bar pot
	$bplot0 = new BarPlot($min);
	$bplot0->SetFillColor("maroon");
	$bplot0->SetLegend("Minimum");
	$bplot1 = new BarPlot($avg);
	$bplot1->SetFillColor("orange");
	$bplot1->SetLegend("Average");
	$bplot2 = new BarPlot($max);
	$bplot2->SetFillColor("blue");
	$bplot2->SetLegend("Maximum");
	
	// Create the grouped bar plot
	$gbplot = new GroupBarPlot(array($bplot0,$bplot1,$bplot2));
	$gbplot->SetWidth(0.7);
	$gbplot->SetShadow();

	// Add the bar to the graph
	$graph->Add($gbplot);

	$graph->Stroke();

?>

