<?php

/*	Generating the graph of response time in various regions for required Transaction for A SPECIFIED PERIOD 
 *	The graph can be either for complete transaction 
 *	
 *	THIS CODE IS VERY SIMILAR TO restimedur.php
 *	The ONLY difference is we are plotting DIFFERENT GRAPHS for EACH LOCATION. 
 *	
 */	

	$jobid = $_GET['jid']; 	// job ID

	// start day of result
	$stday	= $_GET['std']; // day
	$stmon	= $_GET['stm']; // month
	$styr	= $_GET['sty']; // year

	// end day of result
	$enday	= $_GET['end'];	// day
	$enmon	= $_GET['enm'];	// month
	$enyr	= $_GET['eny'];	// year

	$type  = $_GET['type'];	// type of result to be shows - either PG or TRA

	$loctmp = $_GET['loc']; // locations of delegate - it wil be something like "loc1,loc2,loc3,"
	
	// the character comma (",") acts as delimiter for the string of locations
	$delim = ",";
	
	// remove the trailing "," 
	$loctmp = trim($loctmp , $delim );

	// get all the locations in the array 
	$location = explode($delim, $loctmp);
	
	// now, the location array contains all the regions of the delegates

	$day1 = strtotime($styr."-".$stmon."-".$stday."-");	// timestamp for starting day
	$day2 = strtotime($enyr."-".$enmon."-".$enday."-");	// timestamp for ending day

	$diff = ($day2-$day1)/(24*60*60); // difference in number of days

	if ($diff > 7) // if the difference between days is greater than 7 days, give error message
	{
		// echo "error ";
		exit();	
	}

//	$todayts = strtotime(gmdate("M d Y",time())); // get time stamp for today (in GMT)
//	$todayts -= $day * (24*60*60); // get the time stamp for concerned day - eg. day 0 means today, day 1 means yesterday  

	// default values for interval 

	switch ($diff)
	{
		case 1:
			$interval_min = 60;  // interval to be used in graph. 
			$sample_point = 24; // number of points on x-axis 
			break;
		case 2: 
			$interval_min = 120;// interval to be used in graph. 
			$sample_point = 24; // number of points on x-axis 
			break;
		case 3: 
			$interval_min = 180; // interval to be used in graph. 
			$sample_point = 24; // number of points on x-axis 
			break;
		case 4: 
			$interval_min = 240; // interval to be used in graph. 
			$sample_point = 24; // number of points on x-axis 
			break;
		case 5: 
			$interval_min = 360; // interval to be used in graph. 
			$sample_point = 20; // number of points on x-axis 
			break;
		case 6: 
			$interval_min = 360; // interval to be used in graph. 
			$sample_point = 24; // number of points on x-axis 
			break;
		case 7: 
			$interval_min = 360; // interval to be used in graph. 
			$sample_point = 28; // number of points on x-axis 
			break;
	}

	// echo $interval_min."\n\n".$sample_point."\n\n";

	$interval_q = "SELECT NumStep , PPHLoad FROM JobInfo WHERE JobID ='".$jobid."'"; 

	$dbconn = mysql_connect("server_name", "user_name", "password" ) or die("Unable to connect to server."); 
	$result = mysql_select_db("databse_name", $dbconn)  or die ("Unable to select database.");

	$res_int = mysql_query($interval_q) or die("Unable to execute query");
	$int_row = mysql_fetch_assoc($res_int);

	$numstep = $int_row['NumStep'];	// get number of steps in transaction
	
	mysql_free_result($res_int);

//=============== display results for a transaction =================================//

	if ($type != 'TRA') // if type is not TRA, exit
	{
		exit();
 	} // end if type!=tra
	
	// *** create empty canvas for graph 

	// create scale for x-axis
	$step	= $interval_min / 60;	// calculate number of hours to be used as step
	$dy	= $day1;		// timestamp for first day
	$hr	= 0; 			// start hour 
	
	for ($ind=0;$ind<= $sample_point; $ind++)
	{

		$datax[$ind] = date("Y:M:d",$dy)." ".$hr." Hrs "; // text labels for x-axis

		$hr += $step;	// find next label 
		$hr %=24;
		$dy += $interval_min * 60; // update timestamp
	}

	include("jpgraph/jpgraph.php");
	include("jpgraph/jpgraph_line.php");

	// Create the graph. These two calls are always required 
	$graph = new Graph(700,500); 
	$graph->SetScale("textlin"); 

	// colors used for different line plots
	$linecol = array('darkorchid','coral','firebrick1','magenta4','cyan'); 
	$linest  = array('solid', 'dashed', 'dotted', 'solid', 'dotted');

	$numloc = 0;

	while ($numloc < count($location))
	{
	
		// two dimensional array for holding result values
		// first row holds the cumulative response time and second row holds the number of samples 
		// the division will give us the average response time
		$ResArr[0][0] = 0;	

		// average response time
		$avgr[0] = 0;	

		// initialize the array 
		for($init=0; $init <= $sample_point; $init++)
		{
			$ResArr[$init][0] = 0;	// response time
			$ResArr[$init][1] = 0;	// number of samples
			$avgr[$init] = 0;	// average response time
		}

		// select results for given day and lcoation

		$restr_q = "SELECT UNIX_TIMESTAMP(TrStart) as ts, EEResponse FROM TrRes,DelegateInfo WHERE JobID ='".$jobid."' AND TrErr < 1 AND  TrRes.DelID = DelegateInfo.DelID AND DelegateInfo.DReg='".$location[$numloc]."' AND UNIX_TIMESTAMP(TrStart) BETWEEN  ".$day1." AND ".$day2." ;";

		$res	= mysql_query($restr_q) or die("Unable to execute query :restr_q");

		// number of tests conducted is equal to number of results returned
		$numres = mysql_num_rows($res);

		while ($row = mysql_fetch_assoc($res))
		{
			$timest 	= $row['ts'];
			$resptime	= $row['EEResponse'];
		
			// calculate the array index for this result 
			// $ind	= floor( (($timest - $todayts) + ($interval_min * 60)) / ($interval_min * 60));  
			$ind	= floor( ((($timest - $day1)/60) + ($interval_min/2)) / ($interval_min)); 

			if ($ind <= $sample_point)
			{
				$ResArr[$ind][0] += $resptime;	// add response time for this test

				// number of tests increased by 1  - this will be used to calculate avg. response time	
				$ResArr[$ind][1] += 1;		
			}
		}

		/* Free resultset */
		mysql_free_result($res);     

		// flag to check there is atleast one point on the result. 
		// flag = 1 means there exists atleast one point, flag =0 means otherwise
		$flag = 0;

		for ($ind = 0; $ind <= $sample_point; $ind++)
		{
			if ($ResArr[$ind][1] > 0)
			{
				$avgr[$ind] = ceil($ResArr[$ind][0] / $ResArr[$ind][1]);
				
				$flag = 1; // there atleast one point in the graph
			}
			else  // if there is no data, it will be treated as null value
			{
				$avgr[$ind] = "-";
			}
		}

		// if there is no point, insert a dummy value
		if ($flag == 0)
		{
			$avgr[0] = 0;	//dummy value 
		}

		// Create the linear plot for this location
		$lineplot[$numloc]=new LinePlot($avgr); 
		$lineplot[$numloc]->SetColor($linecol[$numloc]); 
		$lineplot[$numloc]->SetStyle($linest[$numloc]); 
		$lineplot[$numloc]->SetWeight(2);
		$lineplot[$numloc]->SetLegend($location[$numloc]);

		// Add the plot to the graph 
		$graph->Add($lineplot[$numloc]); 

		$numloc += 1;
	} // end while

	// Set footer 
	$str = "Generated at  ".gmdate("M d Y H:i:s", time())." GMT ";
	$graph->footer->right->Set($str);
	$graph->footer->center->Set("(C) CSE, IIT Kanpur ");

	// Nice shadow and color
	$graph->SetShadow();
	$graph->SetColor('ivory');

	// Show  grid in background
	$graph->xgrid->Show();

	// Setup margin and titles 
	$graph->img->SetMargin(60,20,20,150); 
	$graph->SetMarginColor("antiquewhite");
	$titlestr = date("M d, Y", $day1)." -TO- ".date("M d, Y", $day2);
	$graph->title->Set($titlestr); // date is the title 

	// set legend position and direction
	$graph->legend->Pos(0.05,0.98,"left","bottom");
	$graph->legend->SetLayout(LEGEND_HOR);
	$graph->legend->SetLineWeight(2);

	$graph->yaxis->SetTitlemargin(45);
	$graph->yaxis->scale->SetGrace(10,0); 	// Make some room at top and bottom of graph	
	// $graph->xaxis->title->Set("Hour of Day"); 
	$graph->xaxis->SetLabelAngle(90); 	// labels will be displayed at 90 degrees
	$graph->yaxis->title->Set("Response Time in millisecond");

	//$graph->yaxis->scale->ticks->Set(500,500); // Set major and minor tick to 500
	$graph->yaxis->scale->ticks->SupressMinorTickMarks(); // Supress minor ticks
	$graph->xaxis->SetTickLabels($datax);
	$graph->xaxis->SetTextLabelInterval(2);
	
	// if there are no points to be displyed, just give an error message
/*	if ($flag == 0)
	{
		$avgr[0] = 0;	//dummy value 
		
		// Create and add a new text
		$txt=new Text("No tests are conducted \n for the given period \n from this location.");
		$txt->Pos(0.5,0.5,"center","center");
		$txt->SetFont(FF_FONT2,FS_BOLD);
		$txt->ParagraphAlign('cenetered');
		$txt->SetBox('yellow','navy','gray');
		$txt->SetColor("red");
		$graph->AddText($txt);
	} 
*/

	// Display the graph 
	$graph->Stroke();
	mysql_close($dbconn);	/* Closing connection */


//=============== display results for a page =================================//
//== NOT IMPLEMENTED. graph from multiple locations for each page will make the graph crowded ===//

/*	if ($type == 'PG') // display result of page
	{
		// three dimensional array for holding result values
		// ResArr[i][j][0] stores cumulative response time for page i, for the time interval j
		// ResArr[i][j][1] stores number of samples for page i, for the time interval j
		// the division will give us the average response time
		$ResArr[0][0][0] = 0;
		
		// average response time
		$avgr[0][0] = 0;
		
		// initialize the array 
		for($init=0; $init <= $sample_point; $init++)
		{
			for ($init2=0; $init2<$numstep;$init2++)
			{
				$ResArr[$init2][$init][0] = 0;		// response time
				$ResArr[$init2][$init][1] = 0;		// number of samples
				$avgr[$init2][$init] = 0;	// average response time
			} // end for init2
		} // end for init

		// select results for given day
		$respg_q = "SELECT UNIX_TIMESTAMP(TrStart) as ts, StepNum, PgResponse FROM TrPageRes WHERE JobID ='".$jobid."' and UNIX_TIMESTAMP(TrStart) between  ".$day1." and ".$day2." ;";

		// echo $respg_q."\n\n";
		$res	= mysql_query($respg_q) or die("Unable to execute query ");
		
	//	echo mysql_num_rows($res);

		while ($row = mysql_fetch_assoc($res))
		{
			$timest 	= $row['ts'];
			$resptime	= $row['PgResponse'];
			$stnum		= $row['StepNum'];
		
			// calculate the array index for this result 
			$ind	= floor(((($timest - $day1)/60) + ($interval_min/2)) / ($interval_min));  

		//	echo $ind."\t\t".$stnum."\n\n";

			if (($ind <= $sample_point) && ($stnum <=$numstep)) // the index is within range and stepnumber is valid
			{
				// add response time for this test
				$ResArr[$stnum-1][$ind][0] += $resptime;	

				// number of tests increased by 1  - this will be used to calculate avg. response time	
				$ResArr[$stnum-1][$ind][1] += 1;		

				// echo $ResArr[$stnum-1][$ind][0]."\t\t".$ResArr[$stnum-1][$ind][1]."\n\n"; 
			}
		}

		// Free resultset 
		
		mysql_free_result($res);     
		mysql_close($dbconn);	//*** Closing connection 

		for ($ind = 0; $ind <= $sample_point; $ind++)
		for ($init2=0; $init2<$numstep;$init2++)
		{
			if ($ResArr[$init2][$ind][1] > 0)
			{
				$avgr[$init2][$ind] = ceil($ResArr[$init2][$ind][0] / $ResArr[$init2][$ind][1]);
			
			}
			else  // if there is no data, it will be treated as null value
			{
				$avgr[$init2][$ind] = "-";	
			}
		}

		$step	= $interval_min / 60;	// calculate number of hours to be used as step
		$dy	= $day1;		// timestamp for first day
		$hr	= 0; 			// start hour 
		
		// create scale for x-axis
		for ($ind=0;$ind<= $sample_point; $ind++)
		{

			$datax[$ind] = date("Y:M:d",$dy)." ".$hr." Hrs "; // text labels for x-axis

			$hr += $step;	// find next label 
			$hr %=24;
			$dy += $interval_min * 60; // update timestamp
		}


		include("jpgraph/jpgraph.php");
		include("jpgraph/jpgraph_line.php");

		// Create the graph. These two calls are always required 
		$graph = new Graph(700,500); 
		$graph->SetScale("textlin"); 

		// Nice shadow and color
		$graph->SetShadow();
		$graph->SetColor('ivory');

		// Setup margin and titles 
		$graph->img->SetMargin(60,20,20,150); 
		$graph->SetMarginColor("antiquewhite");
		$titlestr = date("M d, Y", $day1)." -TO- ".date("M d, Y", $day2);
		$graph->title->Set($titlestr); // date is the title 
		$graph->yaxis->SetTitlemargin(45);
		$graph->yaxis->scale->SetGrace(10,10); 	// Make some room at top and bottom of graph	
		$graph->yaxis->title->Set("Response Time in millisecond");
		$graph->xaxis->SetLabelAngle(90); 	// labels will be displayed at 90 degrees

		// Set footer 
		$str = "Generated at  ".gmdate("M d Y H:i:s", time())." GMT ";
		$graph->footer->right->Set($str);
		$graph->footer->center->Set("(C) CSE, IIT Kanpur ");

		// set legend position and direction
		$graph->legend->Pos(0.05,0.98,"left","bottom");
		$graph->legend->SetLayout(LEGEND_HOR);
		$graph->legend->SetLineWeight(2);


		// show  grid 
		$graph->xgrid->Show();

		//$graph->yaxis->scale->ticks->Set(500,500); // Set major and minor tick to 500
		$graph->yaxis->scale->ticks->SupressMinorTickMarks(); // Supress minor ticks
		$graph->xaxis->SetTickLabels($datax);
		$graph->xaxis->SetTextLabelInterval(2);

		for($ind=0; $ind<$numstep; $ind++)
		{
			// Create the linear plot 
			$lineplot[$ind]=new LinePlot($avgr[$ind]); 
			// $lineplot[$ind]->mark->SetType(MARK_UTRIANGLE);
			
			switch ($ind)
			{
				case 0:
					$lineplot[$ind]->SetColor("blue"); 
					$lineplot[$ind]->SetWeight(2);
					$lineplot[$ind]->SetLegend("Step 1");
					break;

				case 1:
					$lineplot[$ind]->SetColor("maroon"); 
					$lineplot[$ind]->SetWeight(2);
					$lineplot[$ind]->SetLegend("Step 2");
					break;

				case 2:
					$lineplot[$ind]->SetColor("purple3"); 
					$lineplot[$ind]->SetWeight(2);
					$lineplot[$ind]->SetLegend("Step 3");
					break;

			}
			// Add the plot to the graph 
			$graph->Add($lineplot[$ind]); 
		} // end for
		// Display the graph 
		$graph->Stroke();

	} //end if type==pg
*/

?>
