/**.	
 *	Class to convert a string to its base64 encoding string. 	
 *	The authentication of proxy is done with the base 64 encoding of the string "<usename>:<password>"
 *	The requireed encoding array is initialized in constructor.
 *	The encoding method is static, which accepts the input string and returns the base64 encoded string of input.
 *
 */


import java.io.*;

public class Base64 
{

	Base64()
	{

	}

	public static String encode(String in) 
	{
		byte code[] = new byte[64];
		for (int i=0;i<26;i++) code[i]      = (byte)('A' + i);
		for (int i=0;i<26;i++) code[26 + i] = (byte)('a' + i);
		for (int i=0;i<10;i++) code[52 + i] = (byte)('0' + i);
		code[62] = (byte)'+';
		code[63] = (byte)'/';
		int 	c, d, e, end = 0;
		int 	rd = 0;		// read index
		int 	st = 0; 	// store index
		byte 	u, v, w, x;
		int 	inlen	= in.length();
		byte 	input[] = in.getBytes();
		byte 	output[] = new byte[50];

		while( end == 0 )
		{
			if (rd >=inlen)
			{
				c = 0; 
				end =1;
			}
			else 
			{
				c = input[rd++];
			}
			if (rd >=inlen)
			{
				d = 0;
				end +=1;
			}
			else 
			{
				d = input[rd++];
			}
			if (rd >=inlen)
			{
				e = 0; 
				end +=1;
			}
			else 
			{
				e = input[rd++];
			}

			u = code[c >> 2];
			v = code[ ( 0x00000003 & c ) << 4 | d >> 4 ];
			w = code[ ( 0x0000000F & d ) << 2 | e >> 6 ];
			x = code[ e & 0x0000003F ];
			if ( end >= 1 ) x = (byte)'=';
			if ( end == 2 ) w = (byte)'=';
			if ( end < 3 )
			{
				output[st++]= u;
				output[st++]= v;
				output[st++]= w;
				output[st++]= x;
			}
		}
		String enc = new String(output,0,st);
		return enc;
	}
}
