
/**.
 *      All the HTTP request have to be sent in a proper format.
 *      There are various reqeust header, some which have values also.
 *      All such headers are available in this class
 */


interface  HttpHeadGlobal  // class listing various parameters of Http Header
{
        final String	GET = new String("GET ");			// HTTP GET request
	final String	POST = new String ("POST ");			// HTTP POST request
        final String	HTTP10 = new String(" HTTP/1.0 ");		// HTTP version 1.0
        final String	ProxyAuth = new String("Proxy-Authorization: Basic ");	// Proxy Authentication

	// FUTURE ENHANCEMENTS : Parameters needed to access the page with HTTP Version 1.1
	//final String	Http11 = new String(" HTTP/1.1 "); 
        //final String	ProxyConn = new String("Proxy-Connection: Keep-Alive "); 

	// If websites are accessed through proxy server, then proxy provides contents from its cache
	// The Pragma header in request asks proxy to get the fresh content
	// This header is being used to make sure that we get real measurements about the sites
	final String	Pragma	= new String("Pragma: no-cache");
	
	// Content Length (Header field) - required for POST request
	final String	contLen = new String("Content-Length: ");	

	// Content Type (Header Field) - required for POST request
	final String	contType = new String("Content-Type: ");

	// Value for Content-Type Header field  - content is form with Encoded URL 
	final String	urlEncode = new String("application/x-www-form-urlencoded"); 

        // final String	RawMimeHead = new String("");
        final String 	Delim = new String("\r\n");		// delimeter used for the header
	final String	EndReq = new String("\n\n");		// delimeter for end of request
	final char	paramDel = '|';				// delimeter for seperating parameters of GET/POST request
}
